' Kurzzeit-Timer
'
' Einstellen der Zeitdauer in Minutenschritten:
' Erst linke Taste, dann zustzlich rechte Taste drcken. Beide LEDs blinken gleichzeitig.
' Jeder Blinkimpuls steht fr eine Minute.
'
' Start des Timers: rechte Taste drcken.
' Die rechte grne LED blinkt nun im Sekundenrythmus.

' Ist die Zeit abgelaufen, erlischt die grne LED und die rote beginnt hektisch zu blinken.
' Schliet man an Portb.4 einen Piezoschwinger an, ertnen Warnimpulse.

' Der Alarm wird mit der linken Taste gelscht.

' Die Schaltung kann stndig an der Batterie verbleiben, da der Controller im Powerdown nur
' einige A verbraucht.

' Der Controller "merkt" sich dann auch die zuletzt eingestellte Zeit.

' Verwendeter Compiler: BASCOM 2.0.5 DEMO

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

$regfile = "ATtiny13.dat"
$crystal = 1200000                                          ' Taktfrequenz: 1,2MHz
$hwstack = 8                                                ' nur max 4 geschachtelte Unterprogramme; spart SRAM
$swstack = 0                                                ' nicht bentigt; spart SRAM
$framesize = 0                                              ' dito


Buzzer Alias Portb.4
Led1 Alias Portb.1                                          ' grn, rechts
Led2 Alias Portb.3                                          ' rot, links
Taster1 Alias Pinb.0                                        ' links
Taster2 Alias Pinb.2                                        ' rechts


Dim Ti As Byte
Dim Sekunde as Byte
Dim Minute As Byte
Dim Weckzeit As Byte


Clkpr = 128
Clkpr = 3                                                   ' Takt herabsetzen, falls der ATtiny mit 9,6 MHz Takt luft
Clkpr = 3

Acsr.acd = 1                                                ' Analog-Komparator ausschalten, spart etwas Strom
Gimsk.5 = 1                                                 ' Pin Change Interrupt Enable
Sreg.7 = 1                                                  ' Global Interrupt Enable
Pcmsk.2 = 1                                                 ' Pin Change Interrupt PB2 (Taster2) aktivieren
Ddrb = &B00011010                                           ' Portb.1 Portb.3 und Portb.4 Ausgang
Portb = &B00000101                                          ' PullUp-Widerstnde an Pinb.0 und Pinb.2
Didr0 = &B00011010                                          ' nicht bentigte Digital- Eingnge abschalten

On Timer0 Ontimer0                                          ' Interrupt-Routine

Config Timer0 = Timer , Prescale = 256                      ' Ergibt 20 berlufe pro Sekunde, wenn der Tomer nicht bei 0, sondern
                                                            ' bei 22 startet

'
'-------------------------------------------------------------------------------
' Hauptprogramm:


 Do

    Gimsk.5 = 0                                             ' Pin Change Interrupt ausschalten
    Minute = 0

    If Taster1 = 0 Then                                     ' Wirkungsweise: PCINT2 (Taster2) weckt den Controller auf. Nur wenn
        Gosub Einstellen                                    ' er Taster1 bereits gedrckt vorfindet, wird nach "Einstellen" gesprungen                                       ' wird in die Einstell-Routine verzweigt
        Goto Schlafen
    End If

    If Taster2 = 0 Then                                     ' rechter Taster
       Enable Timer0
       Start Timer0

       Do
          If Ti > 18 Then                                   ' Sekunde um
             Ti = 0
             Incr Sekunde
          End If
          If Sekunde > 59 Then
               Sekunde = 0
               Incr Minute
          End If
          If Minute >= Weckzeit Then
              Stop Timer0
              Led2 = 1
              Sound Buzzer, 50, 150
              Led2 = 0
              Waitms 200
          End If
          If Taster1 = 0 Then                               ' linker Taster stellt Alarm ab
              Goto Schlafen
          End if
       Loop

    End If

Schlafen:

    Stop Timer0
    Minute = 0
    Gimsk.5 = 1                                             ' Pin Change Interrupt wieder einschalten
'    Waitms 100
    Powerdown

 Loop



Einstellen:

    Weckzeit = 0
    Do
        Incr Weckzeit                                        ' Minuten-Schritte
        Led1 = 1
        Led2 = 1
        Waitms 100
        Led1 = 0
        Led2 = 0
        Waitms 650
    Loop Until Taster2 = 1
    Wait 1

Return



Ontimer0:                                                    'Timer1-Overflow-Interrupt-Routine

    Tcnt0 = 22                                               ' Preset auf 22, damit er 234 Takte bis Ueberlauf zhlt
    Incr Ti
    If Ti = 1 Then
        Led1 = 1
    Else
        Led1 = 0
    End If

Return


End
